# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with userguide

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}
%define deployer_version 3.2

%bcond_without repolib
%bcond_without zips

%define repodir %{_javadir}/repository.jboss.com/jboss/snowdrop/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           jboss-snowdrop
Version:        1.0.0
Release:        0.1%{?dist}
Epoch:          0
Summary:        Utility package containing JBoss-specific extensions to the Spring Framework
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/snowdrop/tags/1.0.0.GA/ jboss-snowdrop-1.0.0 && tar cjf jboss-snowdrop-1.0.0.tar.bz2 jboss-snowdrop-1.0.0
Source0:        jboss-snowdrop-1.0.0.tar.bz2
Source1:        jboss-snowdrop-jpp-depmap.xml
Source2:        jboss-snowdrop-settings.xml
Source3:        jboss-snowdrop-component-info.xml
Patch0:         jboss-snowdrop-assembly.patch
Patch1:         jboss-snowdrop-samples-pom-version.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  aopalliance >= 0:1.0
# XXX: 0:3.11.0
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  javassist >= 0:3.9.0
BuildRequires:  jboss-aop2 >= 0:2.0.1
BuildRequires:  jboss-cache-pojo >= 0:3.0.0
# XXX: 0:2.0.7-0.CR2
BuildRequires:  jboss-cl >= 0:2.0.6
# XXX 0:2.2.16
BuildRequires:  jboss-common-core >= 0:2.2.14
BuildRequires:  jboss-common-logging-spi >= 0:2.0.5
BuildRequires:  jboss-common-logging-log4j >= 0:2.0.5
# XXX: 0:2.0.8-1.SP1
BuildRequires:  jboss-deployers >= 0:2.0.7
# XXX: for jboss-metadata
BuildRequires:  jboss-jms-1.1-api
# XXX: 0:2.1.1
BuildRequires:  jboss-man >= 0:2.1.0-1.SP1
# XXX: 0:2.0.2
BuildRequires:  jboss-mdr >= 0:2.0.1
BuildRequires:  jboss-microcontainer >= 0:2.0.9
BuildRequires:  jboss-parent >= 0:4
BuildRequires:  jboss-reflect >= 0:2.0.2
BuildRequires:  jboss-test >= 0:1.0.5
# 2) org.jboss.javaee:jboss-ejb-api:jar:3.0.0.GA
# 3) org.jboss.ws.native:jbossws-native-jaxrpc:jar:3.0.4.GA
BuildRequires:  jbossws >= 0:3.0.4
BuildRequires:  jbossxb2 >= 0:2.0.1
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  jta_1_1_api
BuildRequires:  junit44 >= 0:4.4
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-ear
BuildRequires:  maven2-plugin-ejb
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  spring2 >= 0:2.5.6
BuildRequires:  spring2-all >= 0:2.5.6
BuildRequires:  spring2-beans >= 0:2.5.6
BuildRequires:  spring2-context >= 0:2.5.6
BuildRequires:  spring2-core >= 0:2.5.6
BuildRequires:  spring2-web >= 0:2.5.6
BuildRequires:  xerces-j2 >= 0:2.9.1
# samples
BuildRequires:  jakarta-taglibs-standard >= 0:1.1.2
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb3-ext-api
BuildRequires:  spring2-context-support >= 0:2.5.6
BuildRequires:  spring2-webmvc >= 0:2.5.6
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Snowdrop is a utility package that contains JBoss-specific extensions to the
Spring Framework. These extensions are either:

* Extensions to Spring Framework classes, that can be used wherever the generic
  implementations provided by the framework do not integrate correctly with the
  JBoss Application server
* JBoss AS-specific extensions for deploying and running Spring applications

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%if %with zips
%package zip
Summary:        Zips for %{name}
Group:          Development/Libraries/Java

%description zip
Zips for %{name}.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1

%{__cp} -p %{SOURCE2} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir_p} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Daggregate=true \
        javadoc:javadoc

pushd documentation/samples
for d in *; do
    pushd ${d}
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install 
    popd
done
popd

%if %with userguide
pushd documentation/user-guide
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install
popd
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p cluster/target/snowdrop-cluster.jar %{buildroot}%{_javadir}/%{name}/snowdrop-cluster-%{version}.jar
%{__cp} -p cluster/target/snowdrop-cluster-sources.jar %{buildroot}%{_javadir}/%{name}/snowdrop-cluster-sources-%{version}.jar
%{__cp} -p deployers/target/snowdrop-deployers.jar %{buildroot}%{_javadir}/%{name}/snowdrop-deployers-%{version}.jar
%{__cp} -p deployers/target/snowdrop-deployers-sources.jar %{buildroot}%{_javadir}/%{name}/snowdrop-deployers-sources-%{version}.jar
%{__cp} -p facade/target/snowdrop-facade.jar %{buildroot}%{_javadir}/%{name}/snowdrop-facade-%{version}.jar
%{__cp} -p facade/target/snowdrop-facade-sources.jar %{buildroot}%{_javadir}/%{name}/snowdrop-facade-sources-%{version}.jar
%{__cp} -p vfs/target/snowdrop-vfs.jar %{buildroot}%{_javadir}/%{name}/snowdrop-vfs-%{version}.jar
%{__cp} -p vfs/target/snowdrop-vfs-sources.jar %{buildroot}%{_javadir}/%{name}/snowdrop-vfs-sources-%{version}.jar
%{__cp} -p weaving/target/snowdrop-weaving.jar %{buildroot}%{_javadir}/%{name}/snowdrop-weaving-%{version}.jar
%{__cp} -p weaving/target/snowdrop-weaving-sources.jar %{buildroot}%{_javadir}/%{name}/snowdrop-weaving-sources-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-parent.pom
%add_to_maven_depmap org.jboss.snowdrop snowdrop-parent %{namedversion} JPP/%{name} snowdrop-parent
%{__cp} -p cluster/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-cluster.pom
%add_to_maven_depmap org.jboss.snowdrop snowdrop-cluster %{namedversion} JPP/%{name} snowdrop-cluster
%{__cp} -p deployers/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-deployers.pom
%add_to_maven_depmap org.jboss.snowdrop snowdrop-deployers %{namedversion} JPP/%{name} snowdrop-deployers
%{__cp} -p facade/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-facade.pom
%add_to_maven_depmap org.jboss.snowdrop snowdrop-facade %{namedversion} JPP/%{name} snowdrop-facade
%{__cp} -p vfs/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-vfs.pom
%add_to_maven_depmap org.jboss.snowdrop snowdrop-vfs %{namedversion} JPP/%{name} snowdrop-vfs
%{__cp} -p weaving/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-weaving.pom
%add_to_maven_depmap org.jboss.snowdrop snowdrop-weaving %{namedversion} JPP/%{name} snowdrop-weaving

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
%{__sed} -i 's/@VERSION@/%{namedversion}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH1} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-cluster-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-cluster.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-cluster-sources-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-cluster-sources.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-deployers-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-deployers.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-deployers-sources-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-deployers-sources.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-facade-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-facade.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-facade-sources-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-facade-sources.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-vfs-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-vfs.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-vfs-sources-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-vfs-sources.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-weaving-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-weaving.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}/snowdrop-weaving-sources-%{version}.jar %{buildroot}%{repodirlib}/snowdrop-weaving-sources.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-cluster.pom %{buildroot}%{repodirlib}/snowdrop-cluster.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-deployers.pom %{buildroot}%{repodirlib}/snowdrop-deployers.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-facade.pom %{buildroot}%{repodirlib}/snowdrop-facade.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-parent.pom %{buildroot}%{repodirlib}/snowdrop-parent.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-vfs.pom %{buildroot}%{repodirlib}/snowdrop-vfs.pom
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-weaving.pom %{buildroot}%{repodirlib}/snowdrop-weaving.pom
%endif

%if %with zips
%{__mkdir_p} %{buildroot}%{_javadir}/jbossas-fordev
%{__cp} -p build/target/jboss-spring-%{deployer_version}.deployer.zip %{buildroot}%{_javadir}/jbossas-fordev/jboss-spring-%{deployer_version}.deployer.zip
%{__cp} -p build/target/snowdrop-%{namedversion}-lib.zip %{buildroot}%{_javadir}/jbossas-fordev/snowdrop-%{namedversion}-lib.zip
%{__cp} -p build/target/snowdrop-%{namedversion}-libs-with-deps.zip %{buildroot}%{_javadir}/jbossas-fordev/snowdrop-%{namedversion}-libs-with-deps.zip
%{__cp} -p build/target/snowdrop-%{namedversion}-src.zip %{buildroot}%{_javadir}/jbossas-fordev/snowdrop-src.zip
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc build/JBossORG-EULA.txt
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/snowdrop-cluster-%{version}.jar
%{_javadir}/%{name}/snowdrop-cluster.jar
%{_javadir}/%{name}/snowdrop-cluster-sources-%{version}.jar
%{_javadir}/%{name}/snowdrop-cluster-sources.jar
%{_javadir}/%{name}/snowdrop-deployers-%{version}.jar
%{_javadir}/%{name}/snowdrop-deployers.jar
%{_javadir}/%{name}/snowdrop-deployers-sources-%{version}.jar
%{_javadir}/%{name}/snowdrop-deployers-sources.jar
%{_javadir}/%{name}/snowdrop-facade-%{version}.jar
%{_javadir}/%{name}/snowdrop-facade.jar
%{_javadir}/%{name}/snowdrop-facade-sources-%{version}.jar
%{_javadir}/%{name}/snowdrop-facade-sources.jar
%{_javadir}/%{name}/snowdrop-vfs-%{version}.jar
%{_javadir}/%{name}/snowdrop-vfs.jar
%{_javadir}/%{name}/snowdrop-vfs-sources-%{version}.jar
%{_javadir}/%{name}/snowdrop-vfs-sources.jar
%{_javadir}/%{name}/snowdrop-weaving-%{version}.jar
%{_javadir}/%{name}/snowdrop-weaving.jar
%{_javadir}/%{name}/snowdrop-weaving-sources-%{version}.jar
%{_javadir}/%{name}/snowdrop-weaving-sources.jar
%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-cluster.pom
%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-deployers.pom
%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-facade.pom
%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-vfs.pom
%{_datadir}/maven2/poms/JPP.%{name}-snowdrop-weaving.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%if %with zips
%defattr(0644,root,root,0755)
%{_javadir}/jbossas-fordev
%endif

%changelog
* Mon Oct 26 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.1
- release
- samples are not installed
- userguide is not built
